﻿using System.Data.Common;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Metadata;

namespace Drive.Common.Data
{
    public class DriveDbContext(DbContextOptions options) : DbContext(options)
    { }

    internal class DbContextSource
    {
        public static DriveDbContext GetContext(
            IModel model,
            DbConnection connection,
            DbTransaction transaction,
            Action<DbContextOptionsBuilder>? additionalOptions = null)
        {
            DbContextOptionsBuilder builder = new();
            builder.UseSqlServer(
                connection, 
                contextOwnsConnection: false,
                x => x.UseNodaTime().UseQuerySplittingBehavior(QuerySplittingBehavior.SplitQuery));
            builder.UseModel(model);

            additionalOptions?.Invoke(builder);

            DriveDbContext context = new(builder.Options);
            context.Database.UseTransaction(transaction);

            return context;
        }
    }
}
