﻿namespace Drive.Common.Data
{
    public class IdentitySettingsProvider(IdentitySettingsCache cache, SystemUserProvider provider)
    {
        private readonly IdentitySettingsCache _cache = cache;
        private readonly SystemUserProvider _provider = provider;

        public CachedIdentity Get(string tenant)
        {
            _cache.TryGetValue(tenant, out CachedIdentity? identity);
            if (identity == null)
            {
                identity = _provider.Get();
                _cache.Add(tenant, identity);
            }
            return identity;
        }
    }
}
