﻿using Lamar;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Metadata;

namespace Drive.Common.Data
{
    public class DataRegistry :
        ServiceRegistry
    {
        public DataRegistry()
        {
            For<DriveDbContext>()
                .Use(x =>
                {
                    IModel model = x.GetInstance<IModel>();
                    ISqlStorage storage = x.GetInstance<ISqlStorage>();
                    Action<DbContextOptionsBuilder> additionalOptions = x.TryGetInstance<Action<DbContextOptionsBuilder>>();

                    return DbContextSource.GetContext(
                        model,
                        storage.Connection,
                        storage.Transaction,
                        additionalOptions);
                })
                .Scoped();
        }
    }
}