﻿using Microsoft.Data.SqlClient;
using Microsoft.EntityFrameworkCore;

namespace Drive.Common.IntegrationTest.IntegrationDatabaseTest
{
    public class TestIntegrationDatabaseTest : Testing.Database.DatabaseTest
    {
        public readonly string TestCode = "EXIST";

        protected override void AddMappings(ModelBuilder modelBuilder)
        {
            modelBuilder.ApplyConfigurationsFromAssembly(typeof(TestModelMapping).Assembly);
            modelBuilder
                .HasSequence<int>("TestModelIdSequence")
                .StartsAt(1)
                .IsCyclic(false);
            modelBuilder
                .HasSequence<int>("OtherSchemaModelIdSequence")
                .StartsAt(1)
                .IsCyclic(false);
        }

        protected override void AddInitialTestData()
        {
            using SqlConnection connection = OpenConnection();
            using SqlTransaction transaction = connection.BeginTransaction();
            using SqlCommand command = connection.CreateCommand();

            command.Transaction = transaction;
            command.CommandText = string.Format(@"INSERT INTO Test (Code, Description, Active) VALUES
                                                ('{0}', 'Existing Test Object', 1)", TestCode);
            command.ExecuteNonQuery();

            command.CommandText = string.Format(@"INSERT INTO different.Other (Code, Description, Active) VALUES
                                                ('{0}', 'Existing Other Schema Object', 1)", TestCode);
            command.ExecuteNonQuery();

            transaction.Commit();
        }
    }
}