﻿using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Metadata.Builders;

namespace Drive.Common.IntegrationTest.IntegrationDatabaseTest
{
    public class TestModelMapping
        : IEntityTypeConfiguration<TestModel>
    {
        public void Configure(EntityTypeBuilder<TestModel> builder)
        {
            builder.ToTable("Test");
            builder.HasKey(x => x.Id);
            builder
                .Property(x => x.Id)
                .HasDefaultValueSql("NEXT VALUE FOR TestModelIdSequence")
                .IsRequired();

            builder.Property(x => x.Code);
            builder.Property(x => x.Description);
            builder.Property(x => x.Active);
        }
    }

    public class TestAggregateRootModelMapping
        : IEntityTypeConfiguration<TestAggregateRootModel>
    {
        public void Configure(EntityTypeBuilder<TestAggregateRootModel> builder)

        {
            builder.ToTable("TestAggregateRoot");

            builder.HasKey(x => x.Id);
            builder
                .Property(x => x.Id)
                .IsRequired();

            builder
                .Property(x => x.ModifiedAt)
                .IsConcurrencyToken()
                .IsRequired();

            builder.Property(x => x.CreatedAt);
            builder.Property(x => x.CreatedById);
            builder.Property(x => x.ModifiedById);


        }
    }
}